acpi: Add a method to write tables for a device
[oweals/u-boot.git] / test / run
index 6b73813f9bc62732d672cef73d7756f7730aeb44..27331a8e40d1dcc2b6d64a0907b97b60cc725f02 100755 (executable)
--- a/test/run
+++ b/test/run
@@ -1,40 +1,68 @@
 #!/bin/bash
 
+# Script to run all U-Boot tests that use sandbox.
+#  $1: tests to run (empty for all, 'quick' for quick ones only)
+
+# Runs a test and checks the exit code to decide if it passed
+#  $1:         Test name
+#  $2 onwards: command line to run
 run_test() {
-       $@
-       [ $? -ne 0 ] && result=$((result+1))
+       echo -n "$1: "
+       shift
+       "$@"
+       [ $? -ne 0 ] && failures=$((failures+1))
 }
 
-result=0
+# SKip slow tests if requested
+[ "$1" == "quick" ] && mark_expr="not slow"
+[ "$1" == "quick" ] && skip=--skip-net-tests
+[ "$1" == "tools" ] && tools_only=y
+
+failures=0
 
-# Run all tests that the standard sandbox build can support
-run_test ./test/py/test.py --bd sandbox --build
+if [ -z "$tools_only" ]; then
+       # Run all tests that the standard sandbox build can support
+       run_test "sandbox" ./test/py/test.py --bd sandbox --build \
+               -m "${mark_expr}"
+fi
 
 # Run tests which require sandbox_spl
-run_test ./test/py/test.py --bd sandbox_spl --build -k test_ofplatdata.py
+run_test "sandbox_spl" ./test/py/test.py --bd sandbox_spl --build \
+               -k 'test_ofplatdata or test_handoff'
 
-# Run tests for the flat DT version of sandbox
-./test/py/test.py --bd sandbox_flattree --build
+if [ -z "$tools_only" ]; then
+       # Run tests for the flat-device-tree version of sandbox. This is a special
+       # build which does not enable CONFIG_OF_LIVE for the live device tree, so we can
+       # check that functionality is the same. The standard sandbox build (above) uses
+       # CONFIG_OF_LIVE.
+       run_test "sandbox_flattree" ./test/py/test.py --bd sandbox_flattree \
+               --build -k test_ut
+fi
 
 # Set up a path to dtc (device-tree compiler) and libfdt.py, a library it
-# provides and which is built by the sandbox_spl config.
+# provides and which is built by the sandbox_spl config. Also set up the path
+# to tools build by the build.
 DTC_DIR=build-sandbox_spl/scripts/dtc
 export PYTHONPATH=${DTC_DIR}/pylibfdt
 export DTC=${DTC_DIR}/dtc
+TOOLS_DIR=build-sandbox_spl/tools
+
+run_test "binman" ./tools/binman/binman --toolpath ${TOOLS_DIR} test
+run_test "patman" ./tools/patman/patman --test
 
-run_test ./tools/binman/binman -t
-run_test ./tools/patman/patman --test
-run_test ./tools/buildman/buildman -t
-run_test ./tools/dtoc/dtoc -t
+run_test "buildman" ./tools/buildman/buildman -t ${skip}
+run_test "fdt" ./tools/dtoc/test_fdt -t
+run_test "dtoc" ./tools/dtoc/dtoc -t
 
 # This needs you to set up Python test coverage tools.
 # To enable Python test coverage on Debian-type distributions (e.g. Ubuntu):
 #   $ sudo apt-get install python-pytest python-coverage
-run_test ./tools/binman/binman -T
-run_test ./tools/dtoc/dtoc -T
-run_test ./tools/dtoc/test_fdt -T
+export PATH=$PATH:${TOOLS_DIR}
+run_test "binman code coverage" ./tools/binman/binman test -T
+run_test "dtoc code coverage" ./tools/dtoc/dtoc -T
+run_test "fdt code coverage" ./tools/dtoc/test_fdt -T
 
-if [ $result == 0 ]; then
+if [ $failures == 0 ]; then
        echo "Tests passed!"
 else
        echo "Tests FAILED"